package
{
	import flash.display.BitmapDataChannel;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import flash.display.BitmapData;
	import net.flashpunk.Sfx;
	
	/**
	 * klasa automatyzujaca dostep do plikow, ktore zostaly zebrane skrypetem make_embed\embed.php
	 * @author rostok
	 */
	public class Assets
	{
		public static var externalTextures:Object = {};
		
		include "AssetsLookup.as";
		
		// lista uzytych obiektow
		private static var usedAssets:Object = new Object;
		// tablica instancji BitmapData z klas Embed
		private static var bitmapsData:Object = new Object;
		// tablica instancji Image z klas Embed
		private static var images:Object = new Object;
		// tablica instancji Sfx z klas Embed
		private static var sfxs:Object = new Object;
		
		public static function getAsset(name:String):*
		{
			var a:* = assetsLookup[name];
			
			if (a == undefined)
			{
				throw("ERROR! missing asset ", name);
				return null
			}
			
			usedAssets[name] = 1;
			return a;
		}
		
		public static function checkAsset(name:String):Boolean
		{
			var a:* = assetsLookup[name];
			return a != undefined;
		}
		
		// zwraca BitmapData zrobiony na podstawie asseta Embed, tworzy jesli go nie ma, w pamieci jest tylko jedna instancja
		public static function getSingleBitmapData(assetName:String):BitmapData
		{
			if (bitmapsData[assetName] == null)
			{
				var a:Class = getAsset(assetName);
				if (!a)
					return null;
				bitmapsData[assetName] = FP.getBitmap(a);
			}
			return bitmapsData[assetName];
		}
		
		// zwraca Image zrobiony na podstawie asseta Embed, tworzy jesli go nie ma, w pamieci jest tylko jedna instancja
		public static function getSingleImage(assetName:String):Image
		{
			if (images[assetName] == null)
			{
				var a:Class = getAsset(assetName);
				if (!a)
					return null;
				images[assetName] = new Image(a);
			}
			return images[assetName];
		}
		
		// zwraca Sfx zrobiony na podstawie asseta Embed, tworzy jesli go nie ma, w pamieci jest tylko jedna instancja
		public static function getSingleSfx(assetName:String):Sfx
		{
			if (sfxs[assetName] == null)
			{
				var a:Class = getAsset(assetName);
				if (!a)
					return null;
				sfxs[assetName] = new Sfx(a);
			}
			return sfxs[assetName];
		}
		// zwraca image, ktoru nie jest unikalny, ale za to unikalny jest bitmapdata
		public static function getImageFromSingleBitmapData(assetName:String):Image
		{
			var bd:BitmapData = getSingleBitmapData(assetName);
			if (!bd)
				return null;
			return new Image(bd);
		}
		
		// pokazuje co nie zostalo uzyte
		public static function dumpUnused():void
		{
			for (var key:String in assetsLookup)
				if (usedAssets[key] == 1)
				{
					// dlaczego tak to zostawilem?
				}
				else
				{
					trace("unused asset:", key);
				}
		}
	}
}