package
{
	import flash.display.*;
	import flash.events.*;
	import flash.filters.GlowFilter;
	import flash.text.*;
	import flash.utils.getDefinitionByName;

	[SWF(width = "1280", height = "480", backgroundColor="0xFFFFFF")]
	public class Preloader extends Sprite
	{
		[Embed(source = 'data/backgrounds/krupki.jpg')] static private var imgLoading:Class;
		private var loading:Bitmap = new imgLoading;
		
		// Change these values
		private static const mustClick: Boolean = !true;
		private static const mainClassName: String = "Main";
		
		private static const BG_COLOR:uint = 0xFFFFFF;
		private static const FG_COLOR:uint = 0x000000;
		private static const TX_COLOR:uint = 0xEEEEEE;
		
		//[Embed(source = 'net/flashpunk/graphics/04B_03__.TTF', fontFamily = 'default')]
		//private static const FONT:Class;
			
		// Ignore everything else
		
		private var progressBar: Shape;
		private var text: TextField;
		
		private var px:int;
		private var py:int;
		private var w:int;
		private var h:int;
		private var sw:int;
		private var sh:int;
		
		public function Preloader ()
		{
			sw = stage.stageWidth;
			sh = stage.stageHeight;
			
			addChild(loading);

			loading.scaleX = loading.scaleY = sh / loading.height;
			loading.x = sw / 2 - loading.width / 2;
			loading.y = sh / 2 - loading.height / 2;
			w = sw * 1;
			h = sh * 0.015;
			
			px = (sw - w) * 0.5;
			py = (sh) * 0.985;
			
			progressBar = new Shape();
			
			progressBar.graphics.lineStyle(2,0x000000);
			progressBar.graphics.drawRect(px - 2, py - 2, w + 4, h + 4);
			progressBar.graphics.endFill();
			
			addChild(progressBar);
			
			text = new TextField();
			
			text.textColor = TX_COLOR;
			text.selectable = false;
			text.mouseEnabled = false;
			text.defaultTextFormat = new TextFormat("default", 18);
			//text.embedFonts = true;
			text.autoSize = "left";
			text.text = "";// "0%";
			text.x = (sw - text.width) * 0.5;
			text.y = py;
				
			// Apply the glow filter to the cross shape. 
			var glow:GlowFilter = new GlowFilter(); 
			glow.color = 0x303030; 
			glow.alpha = 1; 
			glow.blurX = 5; 
			glow.blurY = 5; 
			 
			text.filters = [glow];

			addChild(text);
			
			stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			if (mustClick) {
				stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			}
		}

		public function onEnterFrame (e:Event): void
		{
			if (hasLoaded())
			{
				//graphics.clear();
				//graphics.beginFill(BG_COLOR);
				//graphics.drawRect(0, 0, sw, sh);
				//graphics.endFill();
				
				if (! mustClick) {
					try {
						startup();
					}
					catch (err:Error)
					{
						trace(err, "not yet");
					}
				} else {
					//text.scaleX = 2.0;
					//text.scaleY = 2.0;
					
					text.text = "";// Kliknij by zacząć";
					//	progressBar.graphics.clear();
			
					//text.y = (sh - text.height) * 0.95;
				}
			} else {
				var p:Number = (loaderInfo.bytesLoaded / loaderInfo.bytesTotal);
				
				//progressBar.graphics.clear();
				progressBar.graphics.beginFill(FG_COLOR);
				progressBar.graphics.drawRect(px, py, p * w, h);
				progressBar.graphics.endFill();
				
				//text.text = int(p * 100) + "%";
			}
			
			text.x = (sw - text.width) * 0.5;
		}
		
		private function onMouseDown(e:MouseEvent):void {
			if (hasLoaded())
			{
				stage.removeEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
				startup();
			}
		}
		
		private function hasLoaded (): Boolean {
			return (loaderInfo.bytesLoaded >= loaderInfo.bytesTotal);
		}
		
		private function startup (): void {
			progressBar.visible = false;
			var mainClass:Class = getDefinitionByName(mainClassName) as Class;
			stage.removeEventListener(Event.ENTER_FRAME, onEnterFrame);
			parent.addChild(new mainClass as DisplayObject);
			parent.removeChild(this);
		}
	}
}