package game 
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author rostok
	 */
	public class Dot extends Entity
	{
		public var imageAsset:String;
		public var follow:Boolean = false;
		
		public function Dot(x:Number=0, y:Number=0, image:String="dot.png") 
		{
			this.image = image;
			this.x = x + 8;
			this.y = y + 8;
		}
		
		public function set image(value:String):void
		{
			this.imageAsset = value;
			var img:Image = Assets.getSingleImage(imageAsset);
			graphic = img;
			graphic.x = -8;
			graphic.y = -8;
			setHitbox(16, 16, 8, 8);
		}

		public function get image():String
		{
			return imageAsset;
		}
		
		override public function update():void 
		{
			if (collide("player", x, y)) {
				world.remove(this);
				Player.dotsCollectedTotal++;
				Assets.getSingleSfx("Pickup_Coin.mp3").play();
			}
			
			if (follow) {
				var p:Point = new Point(Player.instance.x - x, Player.instance.y - y);
				p.normalize(3);
				x += p.x;
				y += p.y;
			}
			
			super.update();
		}
		
		override public function render():void 
		{
			super.render();
			if (FP.console.visible) { 
				Draw.hitbox(this, true, 0xFF0000);
			}
		}
	}

}