package game 
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	/**
	 * ...
	 * @author rostok
	 */
	public class Flower extends Entity
	{
		public var imageAsset:String;
		
		public function Flower(x:Number=0, y:Number=0, image:String="flower1.png") 
		{
			this.image = image;
			this.x = x;
			this.y = y;
		}
		
		public function set image(value:String):void
		{
			this.imageAsset = value;
			var img:Image = Assets.getSingleImage(imageAsset);
			graphic = img;
			setHitbox(img.width, img.height);
		}
		
		public function get image():String
		{
			return imageAsset;
		}
		
		override public function update():void 
		{
			if (collide("player", x, y)) {
				world.remove(this);
				Assets.getSingleSfx("Flower.mp3").play();
				
				var a:Array = new Array();
				world.getClass(Dot, a);
				for each (var d:Dot in a) {
					if (d.distanceFrom(this) < 150) d.follow = true;
				}
			}
			
			super.update();
		}
		
		override public function render():void 
		{
			super.render();
			if (FP.console.visible) { 
				Draw.hitbox(this, true, 0xFF0000);
			}
		}
	}

}