package game 
{
	import flash.geom.Vector3D;
	import flash.media.SoundTransform;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import rostok.Utils;
	/**
	 * ...
	 * @author rostok
	 */
	public class Player extends Entity
	{
		public var dx:Number = 0;
		public var dy:Number = 0;
		public static var assetImageName:String = "kor.png";
		public var sprite:Spritemap = null;
		public var out:Vector3D = new Vector3D();
		public static var instance:Player;
		public static var moveScaleFactor:Number = 4;
		public static var frictionFactor:Number = 0.99;
		
		public static var dotsCollectedTotal:uint = 0;
		public static var dotsNumberTotal:uint = 0;
		
		public function Player(x:Number=0, y:Number=0) 
		{
			instance = this;
			//sprite.add("right" , Utils.getArrRange(0,16), 25, true);
			//sprite.add("left" , Utils.getArrRange(15, 16, -1), 25, true);
			//sprite.play("left");
			//originX = -8;
			//originY = -8;
			//sprite.x = -8;
			name = type = "player";
			reassignSprite();
		}
		
		public function reassignSprite():void 
		{
			trace("reassign " + assetImageName);
			sprite = new Spritemap(Assets.getAsset(assetImageName), 24,24);
			sprite.complete = true;
			sprite.centerOrigin();
			graphic = sprite;
			sprite.scale = 1;
			sprite.y = -12;
			this.x = x;
			this.y = y;
			sprite.scale
			setHitbox(sprite.scaledWidth, sprite.scaledHeight,sprite.scaledWidth/2, sprite.scaledHeight*0.75);
		}
		
		public function checkLineCollisions(edx:Number, edy:Number):Boolean
		{
			var lines:Vector.<Line> = new Vector.<Line>;
			
			world.getType("line", lines );
			for each (var l:Line in lines) {
				if (l.intersects(this, edx, edy)) return true;
			}
			return false;
		}
		
		public function motion():Boolean
		{
			var lines:Vector.<Line> = new Vector.<Line>;
			
			world.getType("line", lines );
			for each (var l:Line in lines) {
				Utils.reflectOnSegment(l.x1, l.y1, l.x2, l.y2, x, y, x + dx, y + dy, out);
				if (out.w != y + dy) { 
					dy = out.w - y;
					dy *= frictionFactor;
				}
				if (out.z != x + dx) { 
					dx = out.z - x;
					dx *= frictionFactor;
				}
			}
			if (out.w != y + dy || out.z != x + dx) return true;

			return false;
		}
		
		override public function update():void 
		{
			instance = this;
			
			// grav
			dy += 0.1 * moveScaleFactor;
			
			if (Input.pressed("up")) { 
				Assets.getSingleSfx("Jump.mp3").play();
				dy -= 1.5 * moveScaleFactor;
			}
			if (Input.pressed("down")) dy += 1 * moveScaleFactor;
			if (Input.check("left")) if (dx>-4*moveScaleFactor) dx -= 0.1 * moveScaleFactor;
			if (Input.check("right")) if (dx<4*moveScaleFactor) dx += 0.1 * moveScaleFactor;
			
			motion();
			//dx = FP.clamp(dx, -5, 5);
			//dy = FP.clamp(dy, -5, 5);

			if (!checkLineCollisions(dx, 0)) x += dx;
			if (!checkLineCollisions(0, dy)) y += dy;
			
			sprite.angle -= dx*5/1.5;
			super.update();
		}
		
		override public function render():void 
		{
			super.render();
			if (FP.console.visible) { 
				Draw.line(x, y, x + dx * 10, y + dy * 10, 0xFF0000);
				Draw.hitbox(this, true, 0xFF0000);
			}
		}
	}

}