package game 
{
	import flash.display.Sprite;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import rostok.FastFont;
	
	/**
	 * triggers various game events when player enters defined area
	 * @author rostok
	 */
	public class Trigger extends Entity 
	{
		public var action:String;
		public var param:String;
		
		/**
		 * trigger constructor
		 * @param	centerX
		 * @param	centerY
		 * @param	_w
		 * @param	_h
		 * @param	_action an action for Main::performAction()
		 * @param	_param parameter for action
		 */
		public function Trigger(centerX:Number=0, centerY:Number=0, _w:Number=0, _h:Number=0, _action:String="", _param:String="") 
		{
			//if (_action == "wrapPlayer") {
				//_w += Number(_param.split(";")[0]);
				//_h += Number(_param.split(";")[0]);
			//}
			x = centerX;
			y = centerY;
			setHitbox(_w, _h, _w / 2, _h / 2);
			action = _action;
			param = _param;
		}

		// checks if player enters area
		override public function update():void 
		{
			if (!Player.instance) return;
			if (collidePoint(x, y, Player.instance.x, Player.instance.y)) {
			//if (collide("player", x, y))  {
				Main.instance.performAction(action, param, this);
			}
		}
		
		// renders area and action/param name while console is visible
		override public function render():void 
		{
			if (!FP.console.visible) return;
			Draw.hitbox(this, true, active ? 0x808000 : 0x404000, 0.5);
			/*
			if (!Input.check("draw_quadtree")) return;
			var txt:Text = new Text(action+"/"+param,0,0,{size:8, color:0x808000});
			Draw.graphic(txt, x - width / 2, y + height / 2);
			super.render();
			*/
			
			// TODO remove 
			if (!collidePoint(x, y, Input.mouseX + world.camera.x, Input.mouseY + world.camera.y)) return;
			FastFont.print(action+"/"+param, x - width / 2, y + height / 2, 0x808000 );
		}
		
	}
 
}