package rostok 
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.text.*;
	import flash.utils.getTimer;
	/**
	 * simple class for checking function timings
	 * @author rostok
	 */
	public class SimpleProfiler 
	{
		private static var beg:Array = [];
		private static var sum:Array = [];
		private static var names:Array = [];
		private static var text: TextField = null;
		private static var namesStack:Array = [];
		private static var DISABLE:Boolean = !true;
		private static var calls:int = 0;
		public function SimpleProfiler(stage:Stage) 
		{
			
			text = new TextField();
			
			text.textColor = 0xFFFFFF;
			text.selectable = false;
			text.mouseEnabled = false;
			text.defaultTextFormat = new TextFormat("default", 18);
			//text.embedFonts = true;
			text.autoSize = "left";
			text.text = "";// "0%";
			text.x = 0;
			text.y = 0;
			calls = 0;
			stage.addChild(text);
		}
		
		// call before tested section
		public static function start(name:String):void 
		{
			if (DISABLE) return;
			var i:int = names.indexOf(name);
			if (i<0) {
				beg[names.length] = getTimer();
				sum[names.length] = 0;
				names.push(name);
			}
			else {
				beg[i] = getTimer();
			}
			namesStack.push(name);
			calls++;
		}

		// call after tested section
		public static function finish():void 
		{
			if (DISABLE) return;
			var name:String = namesStack.pop();
			calls--;
			var i:int = names.indexOf(name);
			sum[i] += getTimer() - beg[i];	
			if (calls == 0 && namesStack.length > 0 ||
				namesStack.length == 0 && calls<0) throw("SimpleProfiler::finish() called to many times"); 
		}
		
		// pads right with spaces
		private static function padRight(v:*, l:int=16, c:String=" "):String
		{
			var s:String = v;
			if (s.length > l) {
				return s.substring(0, l);
			}
			for (var i:int = s.length; i < l; i++)
				s += c;
			return s;
		}

		// pads left with spaces
		private static function padLeft(v:*, l:int=16, c:String=" "):String
		{
			var s:String = v;
			if (s.length > l) {
				return s.substring(0, l);
			}
			for (var i:int = s.length; i < l; i++)
				s = c + s;
			return s;
		}
		
		// return results in string, whole time is the longest section time (main loop for example)
		public static function results():String
		{
			var str:String;
			var i:int;
			var whole:Number = sum[0];
			for (i = 0; i < sum.length; i++) 
				if (sum[i] > whole) whole = sum[i];
			whole /= 1000.0;
			str = padRight("total time:", 40) + " " + whole + "secs\n";
			for (i = 0; i < names.length; i++) {
				var p:Number = sum[i] / 1000.0 / whole * 100;
				str += "\t"+" "+ 
							padRight(names[i], 32) + " " + 
							padRight(Number(sum[i] / 1000.0).toFixed(2), 8) + " " +
							padLeft(p.toFixed(2), 8) + "%\n";
			}
			return str;
		}
		
		// trace results
		public static function traceResults():void 
		{
			if (DISABLE) return;
			var str:String = results();
			//trace(str);
			if (text) {
				text.htmlText = "<font face='courier'>\n\n"+str+"</font>";
			}
			//trace(namesStack);
		}
		
		public static function visible(b:Boolean):void 
		{
			text.visible = b;
		}
		
		public static function switchVisibility():void 
		{
			text.visible = !text.visible;
		}
		
		
	}

}