package rostok {
	import flash.accessibility.Accessibility;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.geom.Vector3D;
	import net.flashpunk.Engine;
	import net.flashpunk.FP;
	
	/* klasa zawiera rozne statyczne funkcje pomocnicze
	 * 
	 * w szczegolnosci szybkie funkcje geometryczne do znadjowania przeciec
	 */ 
	public class Utils {
		// these are temporary vectors for speedup
		private static var _v12:Vector3D = new Vector3D(0,0,0,0);
		private static var _x4:Vector3D = new Vector3D(0,0,0,0);
		private static var _ptn:Point = new Point(0,0);
		public static const SMALL_NUM:Number = 0.00001;
		
		/* return array consisting of number elements starting with startindex
		*/ 
		public static function getArrRange(startIndex:Number, totalLength:Number, inc:int=1):Array
        {
			var a:Array = new Array();
			//for (;totalLength>0;totalLength--) a[a.length]=startIndex++;
			for (;totalLength>0;totalLength--) a.push(startIndex+=inc);
			return a;
        }
			
		/* return array filled with numbers from start to finish
		*/ 
		public static function getIntArr(start:int, finish:int):Array
        {
			var a:Array = new Array();
			var x:int;
			if (start < finish) for (x=start; x<=finish; x++) a.push(x);
			else 				for (x=start; x>=finish; x--) a.push(x);
			return a;
        }
			
        /* linear interpolation from alfa to omega	
		*/
		public static function lerp(alfa:Number, omega:Number, pos:Number):Number 
		{
			return alfa+(omega-alfa)*pos;
		}
		
		/**
		 * returns value 0..1 based on pos between alfa and omega
		 * @return
		 */
		public static function unlerp(alfa:Number, omega:Number, pos:Number):Number
		{
			return (pos - alfa) / (omega - alfa);
		}

		/* check if two segments intersect
		 */
		public static function ptsits2d(p1x:Number,p1y:Number,p2x:Number,p2y:Number,p3x:Number,p3y:Number,p4x:Number,p4y:Number):Boolean
		{
			var w21x:Number = p2x - p1x;  var w21y:Number = p2y - p1y;
			var w31x:Number = p3x - p1x;  var w31y:Number = p3y - p1y;
			var w41x:Number = p4x - p1x;  var w41y:Number = p4y - p1y;
			var w43x:Number = p4x - p3x;  var w43y:Number = p4y - p3y;
			var w23x:Number = p2x - p3x;  var w23y:Number = p2y - p3y;

			if (((w21x*w31y-w21y*w31x)*(w21x*w41y-w21y*w41x)) > 0) return false;
			if (((w43x*w23y-w43y*w23x)*(w31x*w43y-w31y*w43x)) > 0) return false;
			return true;
		}

		/* intersection when first one is vertical (p2x, p1x are equal), 
		 */
		public static function vptsits2d(p1x:Number,p1y:Number,p2x:Number,p2y:Number,p3x:Number,p3y:Number,p4x:Number,p4y:Number):Boolean
		{
										  var w21y:Number = p2y - p1y;
			var w31x:Number = p3x - p1x;  var w31y:Number = p3y - p1y;
			var w41x:Number = p4x - p1x;  //var w41y:Number = p4y - p1y;
			var w43x:Number = p4x - p3x;  var w43y:Number = p4y - p3y;
			var w23x:Number = p2x - p3x;  var w23y:Number = p2y - p3y;
			 
			if (((         -w21y*w31x)*(         -w21y*w41x)) > 0) return false;
			if (((w43x*w23y-w43y*w23x)*(w31x*w43y-w31y*w43x)) > 0) return false;
			return true;
		}

        /* checks if two semgents intersect, first one is horizontal (p2y and p1y are equal)
		 */ 
		public static function hptsits2d(p1x:Number,p1y:Number,p2x:Number,p2y:Number,p3x:Number,p3y:Number,p4x:Number,p4y:Number):Boolean
		{
			var w21x:Number = p2x - p1x;  
			var w31x:Number = p3x - p1x;  var w31y:Number = p3y - p1y;
			/*var w41x:Number = p4x - p1x;*/  var w41y:Number = p4y - p1y;
			var w43x:Number = p4x - p3x;  var w43y:Number = p4y - p3y;
			var w23x:Number = p2x - p3x;  var w23y:Number = p2y - p3y;

			if (((w21x*w31y          )*(w21x*w41y          )) > 0) return false;
			if (((w43x*w23y-w43y*w23x)*(w31x*w43y-w31y*w43x)) > 0) return false;
			return true;
		}

        /* finds intersection of two segments 
		 * returns Vector3d:
		 * x,y - intersection point
		 * if w==0 there is no intersection
		 */
		public static function getits2d(p1x:Number,p1y:Number,p2x:Number,p2y:Number,p3x:Number,p3y:Number,p4x:Number,p4y:Number, output:Vector3D):void
		{
			var w21x:Number = p2x - p1x;  var w21y:Number = p2y - p1y;
			var w31x:Number = p3x - p1x;  var w31y:Number = p3y - p1y;
			var w41x:Number = p4x - p1x;  var w41y:Number = p4y - p1y;
			var w43x:Number = p4x - p3x;  var w43y:Number = p4y - p3y;
			var w23x:Number = p2x - p3x;  var w23y:Number = p2y - p3y;

			output.x = 0;
			output.y = 0;
			output.z = 0;
			output.w = 0;
			if (((w21x*w31y-w21y*w31x)*(w21x*w41y-w21y*w41x )) > 0) return ;
			if (((w43x*w23y-w43y*w23x)*(w31x*w43y-w31y*w43x )) > 0) return ;
			w41x = (w43x*w21y-w43y*w21x)
			if ( w41x == 0 ) return ;
			w41y = (w43x*w31y-w43y*w31x)/w41x;
			output.x = p1x+w21x*w41y;
			output.y = p1y+w21y*w41y;
			output.w = 1;
		}
			
        /* cuts second segment with first one 
		 * returns true on cut
		 * 
		 * result in output as Vector3d:
		 * x,y - start point
		 * z,w - end point
		 * if there is no intersection returned vector represents second segment
		 */
		public static function cutSegment(p1x:Number,p1y:Number,p2x:Number,p2y:Number,p3x:Number,p3y:Number,p4x:Number,p4y:Number, output:Vector3D):Boolean
		{			
			var w21x:Number = p2x - p1x;  var w21y:Number = p2y - p1y;
			var w31x:Number = p3x - p1x;  var w31y:Number = p3y - p1y;
			var w41x:Number = p4x - p1x;  var w41y:Number = p4y - p1y;
			var w43x:Number = p4x - p3x;  var w43y:Number = p4y - p3y;
			var w23x:Number = p2x - p3x;  var w23y:Number = p2y - p3y;

			output.x = p3x;
			output.y = p3y;
			output.z = p4x;
			output.w = p4y;
			if (((w21x*w31y-w21y*w31x)*(w21x*w41y-w21y*w41x )) > 0) return false;
			if (((w43x*w23y-w43y*w23x)*(w31x*w43y-w31y*w43x )) > 0) return false;
			w41x = (w43x*w21y-w43y*w21x)
			if ( w41x == 0 ) return false;
			w41y = (w43x*w31y-w43y*w31x)/w41x;
			output.z = p1x+w21x*w41y;
			output.w = p1y + w21y * w41y;
			return true;
			
			
			//output = oldcutSegment(p1x, p1y, p2x, p2y, p3x, p3y, p4x, p4y);
			//return (p2x != output.z || p2y != output.w);
		}
			
		/* cuts second (q) segment with first (p) one then casts cut off part onto first (p) segment
		 * returns 
		 * 	- unchanged q1 to q2 segment when no intersection
		 *  - segment from intersection to end
		 *  - q1 to intersection if input segments are perpendicular
		 * good for sliding along the walls
		 */
		public static function slideOnSegment(p1x:Number,p1y:Number,p2x:Number,p2y:Number,q1x:Number,q1y:Number,q2x:Number,q2y:Number, output:Vector3D):void
		{
			cutSegment(p1x, p1y, p2x, p2y, q1x, q1y, q2x, q2y, output);
			if (q2x == output.z && q2y == output.w) return; // szybki powrot jesli sie nic nie zmienilo
			_v12.x = p2x - p1x;
			_v12.y = p2y - p1y; // przecinajacy p2-p1
			_v12.w = _v12.z = 0;
			_x4.x = q2x - output.z;
			_x4.y = q2y - output.w; // przecinany  p4-p3
			_x4.w = _x4.z = 0;
			_v12.scaleBy( _v12.dotProduct(_x4) / _v12.lengthSquared);
			
			// pierwszy punkt v staje sie punktem przeciecia !!!!
			output.x = output.z; output.y = output.w;
			
			output.z += _v12.x;
			output.w += _v12.y;
		}
			
		/* cuts second (q) segment with first (p) one then reflects cut off part by first (p) segment
		 * returns 
		 * 	- unchanged q1 to q2 segment when no intersection
		 *  - segment from intersection to reflected end
		 */
		public static function reflectOnSegment(p1x:Number,p1y:Number,p2x:Number,p2y:Number,q1x:Number,q1y:Number,q2x:Number,q2y:Number, output:Vector3D):void
		{
			cutSegment(p1x, p1y, p2x, p2y, q1x, q1y, q2x, q2y, output);
			if (q2x == output.z && q2y == output.w) return; // szybki powrot jesli sie nic nie zmienilo
			_v12.x = p2x - p1x;
			_v12.y = p2y - p1y; // przecinajacy p2-p1
			_v12.w = _v12.z = 0;
			_x4.x = q2x - output.z;
			_x4.y = q2y - output.w; // przecinany  p4-p3
			_x4.w = _x4.z = 0;
			_v12.scaleBy( _v12.dotProduct(_x4) / _v12.lengthSquared);
			
			// pierwszy punkt v staje sie punktem przeciecia !!!!
			output.x = output.z; output.y = output.w;
			
			output.z += _v12.x;
			output.w += _v12.y;
			
			output.z += output.z - q2x;
			output.w += output.w - q2y;
		}
		
		/* check if segment intersects with rectangle 
		 * return true if it does
		 */
		public static function isRectSegIntersection(	rectMinX:Number, rectMinY:Number, 
								rectMaxX:Number, rectMaxY:Number, 
								p1x:Number, p1y:Number, 
								p2x:Number, p2y:Number):Boolean
		{
			// nie oplaca sie sprawdzac nachodzenia pionowego, testy nie wykazaly ze to daje wzrost fpsow
			// Find min and max X for the segment
			var minX:Number;
			var maxX:Number;

			if(p1x > p2x) {
				minX = p2x;
				maxX = p1x;
			} else {
				minX = p1x;
				maxX = p2x;
			}

			//if (maxX < rectMinX) return false;
			//if (minX > rectMaxX) return false;
			
			// Find the intersection of the segment's and rectangle's x-projections
			if(maxX > rectMaxX) maxX = rectMaxX;
			if(minX < rectMinX) minX = rectMinX;
			
			// If their projections do not intersect return false
			if(minX > maxX) return false;
			
			// Find corresponding min and max Y for min and max X we found before
			var minY:Number = p1y;
			var maxY:Number = p2y;
			var dx:Number = p2x - p1x;

			//if(Math.abs(dx) > SMALL_NUM) {
			if(dx > SMALL_NUM || dx < -SMALL_NUM) {
				var a:Number = (p2y - p1y) / dx;
				var b:Number = p1y - a * p1x;
				minY = a * minX + b;
				maxY = a * maxX + b;
			}

			if(minY > maxY) {
				var tmp:Number = maxY;
				maxY = minY;
				minY = tmp;
			}

			// Find the intersection of the segment's and rectangle's y-projections
			if(maxY > rectMaxY) maxY = rectMaxY;
			if(minY < rectMinY) minY = rectMinY;
			// If Y-projections do not intersect return false
			if(minY > maxY) return false;

			return true;
		}

		/* slides segment on rect
		 * returns in outpur new segment, same as argument when no collision
		 * 
		 * true on slide
		 * false there was no collision
		 */
		public static function slideOnRect(rectMinX:Number, rectMinY:Number, rectMaxX:Number, rectMaxY:Number, 
						 p1x:Number, p1y:Number, p2x:Number, p2y:Number, output:Vector3D):Boolean
		{
			output.x = p1x;
			output.y = p1y;
			output.z = p2x;
			output.w = p2y;
			var cutter:Boolean = false;
			var cutterx:Number;
			var cuttery:Number;
			var cutterz:Number;
			var cutterw:Number;
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true;  cutterx = rectMinX; cuttery = rectMinY; cutterz = rectMaxX; cutterw = rectMinY; }
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true; cutterx = rectMaxX; cuttery = rectMinY; cutterz = rectMaxX; cutterw = rectMaxY; }
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true; cutterx = rectMaxX; cuttery = rectMaxY; cutterz = rectMinX; cutterw = rectMaxY; }
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true; cutterx = rectMinX; cuttery = rectMaxY; cutterz = rectMinX; cutterw = rectMinY; }
			
			if (cutter) {
				slideOnSegment(cutterx, cuttery, cutterz, cutterw, p1x, p1y, p2x, p2y, output);
				return true;
			}
			
			return false;
		}
		
		/* reflects segment on rect
		 * returns new segment, same as argument when no collision
		 * 
		 * true there was reflection
		 * false there was no collision
		 */
		public static function reflectOnRect(rectMinX:Number, rectMinY:Number, rectMaxX:Number, rectMaxY:Number, 
						 p1x:Number, p1y:Number, p2x:Number, p2y:Number, output:Vector3D):Boolean
		{
			output.x = p1x;
			output.y = p1y;
			output.z = p2x;
			output.w = p2y;
			var cutter:Boolean = false;
			var cutterx:Number;
			var cuttery:Number;
			var cutterz:Number;
			var cutterw:Number;
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true;  cutterx = rectMinX; cuttery = rectMinY; cutterz = rectMaxX; cutterw = rectMinY; }
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true; cutterx = rectMaxX; cuttery = rectMinY; cutterz = rectMaxX; cutterw = rectMaxY; }
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true; cutterx = rectMaxX; cuttery = rectMaxY; cutterz = rectMinX; cutterw = rectMaxY; }
			
			if (cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output)) { cutter = true; cutterx = rectMinX; cuttery = rectMaxY; cutterz = rectMinX; cutterw = rectMinY; }
			
			if (cutter) {
				reflectOnSegment(cutterx, cuttery, cutterz, cutterw, p1x, p1y, p2x, p2y, output);
				return true;
			}
			
			return false;

		}
		
		/* cuts segment with rect
		 * returns new segment, same as argument when no collision
		 */
		public static function cutSegmentWithRect(rectMinX:Number, rectMinY:Number, rectMaxX:Number, rectMaxY:Number, 
						 p1x:Number, p1y:Number, p2x:Number, p2y:Number, output:Vector3D):void
		{
			output.x = p1x;
			output.y = p1y;
			output.z = p2x;
			output.w = p2y;
			
			cutSegment(rectMinX, rectMinY, rectMaxX, rectMinY, output.x, output.y, output.z, output.w, output);
			cutSegment(rectMaxX, rectMinY, rectMaxX, rectMaxY, output.x, output.y, output.z, output.w, output);
			cutSegment(rectMaxX, rectMaxY, rectMinX, rectMaxY, output.x, output.y, output.z, output.w, output);
			cutSegment(rectMinX, rectMaxY, rectMinX, rectMinY, output.x, output.y, output.z, output.w, output);
		}
		
		/* returns smallest distance between two segments
		 * 
		 * source: http://www.softsurfer.com/Archive/algorithm_0106/algorithm_0106.htm
		 * source: http://www.sorgonet.com/linux/openglguide/mates.html
		 */ 
		public static function segmentsDistance(p1x:Number,p1y:Number,p2x:Number,p2y:Number,q1x:Number,q1y:Number,q2x:Number,q2y:Number):Number
		{
			//Vector   u = S1.P1 - S1.P0;
			var ux:Number = p2x - p1x;
			var uy:Number = p2y - p1y;
			//Vector   v = S2.P1 - S2.P0;
			var vx:Number = q2x - q1x;
			var vy:Number = q2y - q1y;
			//Vector   w = S1.P0 - S2.P0;
			var wx:Number = p1x - q1x;
			var wy:Number = p1y - q1y;
			
			//float    a = dot(u,u);        // always >= 0
			var a:Number = ux * ux + uy * uy;
			//float    b = dot(u,v);
			var b:Number = ux * vx + uy * vy;
			//float    c = dot(v,v);        // always >= 0
			var c:Number = vx * vx + vy * vy;
			//float    d = dot(u,w);
			var d:Number = ux * wx + uy * wy;
			//float    e = dot(v,w);
			var e:Number = vx * wx + vy * wy;
			//float    D = a*c - b*b;       // always >= 0
			var D:Number = a*c - b*b;
			//float    sc, sN, sD = D;      // sc = sN / sD, default sD = D >= 0
			var sc:Number, sN:Number, sD:Number = D;
			//float    tc, tN, tD = D;      // tc = tN / tD, default tD = D >= 0
			var tc:Number, tN:Number, tD:Number = D;      // tc = tN / tD, default tD = D >= 0

			// compute the line parameters of the two closest points
			if (D < SMALL_NUM) { // the lines are almost parallel
				sN = 0.0;        // force using point P0 on segment S1
				sD = 1.0;        // to prevent possible division by 0.0 later
				tN = e;
				tD = c;
			}
			else {                // get the closest points on the infinite lines
				sN = (b*e - c*d);
				tN = (a*e - b*d);
				if (sN < 0.0) {       // sc < 0 => the s=0 edge is visible
					sN = 0.0;
					tN = e;
					tD = c;
				}
				else if (sN > sD) {  // sc > 1 => the s=1 edge is visible
					sN = sD;
					tN = e + b;
					tD = c;
				}
			}

			if (tN < 0.0) {           // tc < 0 => the t=0 edge is visible
				tN = 0.0;
				// recompute sc for this edge
				if (-d < 0.0)
					sN = 0.0;
				else if (-d > a)
					sN = sD;
				else {
					sN = -d;
					sD = a;
				}
			}
			else if (tN > tD) {      // tc > 1 => the t=1 edge is visible
				tN = tD;
				// recompute sc for this edge
				if ((-d + b) < 0.0)
					sN = 0;
				else if ((-d + b) > a)
					sN = sD;
				else {
					sN = (-d + b);
					sD = a;
				}
			}
			// finally do the division to get sc and tc
			sc = ((sN < 0 ? -sN:sN) < SMALL_NUM ? 0.0 : sN / sD);
			tc = ((tN < 0 ? -tN:tN) < SMALL_NUM ? 0.0 : tN / tD);

			// get the difference of the two closest points
			//Vector   dP = w + (sc * u) - (tc * v);  // = S1(sc) - S2(tc)
			_x4.x = wx + sc * ux - tc * vx;
			_x4.y = wy + sc * uy - tc * vy;
			_x4.z = 0;
			_x4.w = 0;
			
			//return norm(dP);   // return the closest distance
			return _x4.length;
		}
		
		public static function capsulesIntersect(p1x:Number,p1y:Number,p2x:Number,p2y:Number,q1x:Number,q1y:Number,q2x:Number,q2y:Number,r1:Number=0, r2:Number=0):Boolean 
		{
			return segmentsDistance(p1x, p1y, p2x, p2y, q1x, q1y, q2x, q2y) < r1 + r2;
		}
		
		/* checks if px,py is inside a triangle
		 * return true on success
		 */
		public static function isInTriangle(Px:Number, Py:Number, Ax:Number, Ay:Number, Bx:Number, By:Number, Cx:Number, Cy:Number):Boolean
		{
			// Compute vectors        
			var v0x:Number = Cx - Ax;
			var v0y:Number = Cy - Ay;
			var v1x:Number = Bx - Ax;
			var v1y:Number = By - Ay;
			var v2x:Number = Px - Ax;
			var v2y:Number = Py - Ay;

			// Compute dot products
			var dot00:Number = v0x * v0x + v0y * v0y;
			var dot01:Number = v0x * v1x + v0y * v1y;
			var dot02:Number = v0x * v2x + v0y * v2y;
			var dot11:Number = v1x * v1x + v1y * v1y;
			var dot12:Number = v1x * v2x + v1y * v2y;

			// Compute barycentric coordinates
			var invDenom:Number = (dot00 * dot11 - dot01 * dot01);
			if (invDenom == 0) return false;
			invDenom = 1 / invDenom;
			var u:Number = (dot11 * dot02 - dot01 * dot12) * invDenom;
			var v:Number = (dot00 * dot12 - dot01 * dot02) * invDenom;

			// Check if point is in triangle
			return (u > 0) && (v > 0) && (u + v < 1);
		}
		
		// TODO optimize
		/* i don't trust Rect::union()
		 */
		public static function unionRects(r:Rectangle, s:Rectangle):Rectangle
		{
			return new Rectangle( 	Math.min(r.x, s.x),
									Math.min(r.y, s.y),
									Math.max(r.right, s.right)-Math.min(r.x, s.x),
									Math.max(r.bottom, s.bottom)-Math.min(r.y, s.y) );
		}
		

		/* returns direction vector based on direction string
		 */
		public static function getDir(dirString:String, newDir:Point):void
		{
			newDir.x = 0;
			newDir.y = 0.5;
			switch (dirString) 
			{
				case "n" : newDir.x = 0; newDir.y =-0.5;  break;
				case "e" : newDir.x = 1; newDir.y = 0.0;  break;
				case "w" : newDir.x =-1; newDir.y = 0.0;  break;
				case "s" : newDir.x = 0; newDir.y = 0.5;  break;
				case "nw": newDir.x =-1; newDir.y =-0.5;  break;
				case "ne": newDir.x = 1; newDir.y =-0.5;  break;
				case "sw": newDir.x =-1; newDir.y = 0.5;  break;
				case "se": newDir.x = 1; newDir.y = 0.5;  break;
			}
		}
		
		/* returns string with direction closest to vector
		 */
		public static function getStrDir(x:Number, y:Number, defaultDir:String=""):String
		{
			if (x == 0 && y == 0 && defaultDir != "") return defaultDir;
			
			// liczy w couterclockwise, zaczyna poziomo z prawej
			var a:int = (FP.angle(0, 0, x, y)+22.5)%360 / 45 ;
			switch (a) 
			{
				case 0: return "e";
				case 1: return "ne";
				case 2: return "n";
				case 3: return "nw";
				case 4: return "w";
				case 5: return "sw";
				case 6: return "s";
				default:return "se"; // 7
			}
			//var r:String = "";
			//if (x < 0) r = "w";
			//if (x > 0) r = "e";
			//if (y < 0) r = "n"+r;
			//if (y > 0) r = "s"+r;
			//if (r == "") r = defaultDir;
			//return r;
		}
		
		// TODO optimize
		/* corrects direction vector shortening vertical part
		 */
		public static function correctDirectionVec(output:Vector3D):void
		{
			if ((output.y < 0 ? -output.y : output.y) < SMALL_NUM) return;

			_x4.x = output.x;
			_x4.y = output.y;
			_x4.z = 0;
			_x4.w = 0;
			
			var x:Number;
			var y:Number;

			var vlensq:Number = output.length;
			if (vlensq < SMALL_NUM) {
				output.x = 0;
				output.y = 0;
				output.z = 0;
				output.w = 0;
				return ;
			}
			//v.scaleBy(1.0 / vlensq);
			output.x /= vlensq;
			output.y /= vlensq;
			y = Math.sqrt( 0.5 * output.y * output.y / (output.y * output.y + 0.5 * output.x * output.x) ); // albo  zamiast 0.5 0.25
			x = output.x * y / output.y;
			output.x = x;
			output.y = y;
			output.z = 0;
			output.w = 0;
			vlensq *= output.length;
			_x4.normalize();
			_x4.scaleBy(vlensq);
			output.x = _x4.x;
			output.y = _x4.y;
			output.z = 0;
			output.w = 0;
		}

		// TODO optimize
		/* corrects direction vector (in point type) shortening vertical part
		 */
		public static function correctDirection(vp:Point, clampToInt:Boolean=false):Point
		{
			//return correctDirectionVector(new Vector3D(v.x, v.y)).clone();
			var v:Point = vp.clone();
			var saved:Point = vp.clone();
			
			var x:Number;
			var y:Number;
			var vlensq:Number = v.length;
			if (vlensq < SMALL_NUM) return new Point();
			if (Math.abs(v.y) < SMALL_NUM) return v;
			v.x /= vlensq;
			v.y /= vlensq;
			y = Math.sqrt( 0.5 * v.y * v.y / (v.y * v.y + 0.5 * v.x * v.x) ); // albo  zamiast 0.5 0.25
			x = v.x * y / v.y;
			v = new Point(x, y);
			vlensq *= v.length;
			saved.normalize(vlensq);
			if (clampToInt) {
				saved.x = int(saved.x);
				saved.y = int(saved.y);
			}
			return saved;
		}
		
		/* corrects direction vector (in point type) shortening vertical part
		 */
		public static function correctDirection2(vp:Point, out:Point, clampToInt:Boolean=false):void
		{
			out.x = vp.x;
			out.y = vp.y;
			var saved:Point = vp.clone();
			
			var x:Number;
			var y:Number;
			var vlensq:Number = Math.sqrt(vp.x * vp.x + vp.y * vp.y);
			if (vlensq < SMALL_NUM) { out.x = out.y = 0;  return; }
			if (Math.abs(vp.y) < SMALL_NUM) return;
			out.x /= vlensq;
			out.y /= vlensq;
			y = Math.sqrt( 0.5 * out.y * out.y / (out.y * out.y + 0.5 * out.x * out.x) ); // albo  zamiast 0.5 0.25
			x = out.x * y / out.y;
			vlensq *= Math.sqrt(x * x + y * y);
			out.x = vp.x;
			out.y = vp.y;
			out.normalize(vlensq);
			if (clampToInt) {
				out.x = int(out.x);
				out.y = int(out.y);
			}
		}
		
		/* ultra fast max metric
		 * returns bigger horizontal or vertical absolute difference
		 */
		public static function maxMetric(x:Number, y:Number, dx:Number, dy:Number):Number
		{
			x -= dx;
			y -= dy;
			x = x < 0 ? -x : x;
			y = y < 0 ? -y : y;
			return (x > y) ? x : y; 
		}
		
		/*
		Calculate the intersection of a ray and a sphere
		The line segment is defined from p1 to p2
		The sphere is of radius r and centered at sc
		Return FALSE if the ray doesn't intersect the sphere.
		*/
		public static function isRayCircleIntersection(p1x:Number, p1y:Number, p2x:Number, p2y:Number, scx:Number, scy:Number, r:Number):Boolean
		{
			var dpx:Number = p2x - p1x;
			var dpy:Number = p2y - p1y;
			var a:Number = dpx * dpx + dpy * dpy;
			var b:Number = 2 * (dpx * (p1x - scx) + dpy * (p1y - scy));
			var c:Number = scx * scx + scy * scy;
			c += p1x * p1x + p1y * p1y;
			c -= 2 * (scx * p1x + scy * p1y);
			c -= r * r;
			var bb4ac:Number = b * b - 4 * a * c;
			if (bb4ac < 0 || (a > 0?a: -a) < SMALL_NUM ) return false;
			/*
			mu1 = (-b + sqrt(bb4ac)) / (2 * a);
			mu2 = (-b - sqrt(bb4ac)) / (2 * a);

			There are potentially two points of intersection given by
			p = p1 + mu1 (p2 - p1)
			p = p1 + mu2 (p2 - p1)
			*/
			return true;
		}
		
		/* returns closest point on line segment
		 * @returnedPoint already allocated Point
		 */ 
		public static function closestPointOnSegment(p1x:Number, p1y:Number, p2x:Number, p2y:Number, scx:Number, scy:Number, returnedPoint:Point):void
		{
			var vx:Number = p2x-p1x;
			var vy:Number = p2y-p1y;
			var wx:Number = scx-p1x;
			var wy:Number = scy-p1y;
			var wDotv:Number = wx*vx+wy*vy;
			var t:Number = wDotv / (vx*vx+vy*vy);
			t = t<0 ? 0 : ( t>1 ? 1 : t );
			returnedPoint.x = p1x + vx * t;
			returnedPoint.y = p1y + vy * t;
		}
		
		/* returns true if circle intersects line segment
		 * taken from http://blog.generalrelativity.org/actionscript-30/collision-detection-circleline-segment-circlecapsule/
		 */ 
		public static function isSegmentCircleIntersection(p1x:Number, p1y:Number, p2x:Number, p2y:Number, scx:Number, scy:Number, r:Number):Boolean
		{
			var vx:Number = p2x - p1x;
			var vy:Number = p2y - p1y;
			var wx:Number = scx - p1x;
			var wy:Number = scy - p1y;
			var wDotv:Number = wx * vx + wy * vy;
			var t:Number = wDotv / (vx * vx + vy * vy);
			t = t<0 ? 0 : ( t>1 ? 1 : t ); // closest point is inlined
			var px:Number = p1x + vx * t - scx;
			var py:Number = p1y + vy * t - scy;
			return px * px + py * py < r * r;
		}

		// returns distance
		public static function distance(p1x:Number, p1y:Number, p2x:Number, p2y:Number):Number
		{
			p1x = p1x - p2x;
			p1y = p1y - p2y;
			return Math.sqrt(p1x * p1x + p1y * p1y);
		}

		// returns distance squared
		public static function distanceSquared(p1x:Number, p1y:Number, p2x:Number, p2y:Number):Number
		{
			p1x = p1x - p2x;
			p1y = p1y - p2y;
			return p1x * p1x + p1y * p1y;
		}

		// true is x,y is near px,py, radius enough
		public static function isNear(x:Number, y:Number, px:Number, py:Number, radius:Number):Boolean
		{
			x = x - px;
			y = y - py;
			return x * x + y * y < radius * radius;
		}
		
		// http://snipplr.com/view/33913/
                public static function convertTime(secs:Number):String
                {
	                var h:Number=Math.floor(secs/3600);
        	        var m:Number=Math.floor((secs%3600)/60);
                	var s:Number=Math.floor((secs%3600)%60);
	                return(h==0?"00:":(h<10?"0"+h.toString()+":":h.toString()+":"))+(m<10?"0"+m.toString():m.toString())+":"+(s<10?"0"+s.toString():s.toString());
                }
	}
}